//+------------------------------------------------------------------+
//|                                                   ma crosses.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Red

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    CandleSize      = 50;
extern bool   ShowArrows      = true;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;

//
//
//
//
//

double Bull[];
double Bear[];
double trend[];

double point = 0;
double pipMultiplier = 1;
int    dg;

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   dg=Digits;
   if(dg==3 || dg==5){point=Point*10;pipMultiplier=10;}else{point=Point;pipMultiplier=1;}
   
   IndicatorBuffers(3); 
   SetIndexBuffer(0,Bull);
   SetIndexBuffer(1,Bear);
   SetIndexBuffer(2,trend);  
   
   if (ShowArrows)
            {
               SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,233);
               SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,234);
            }
            else
            {
               SetIndexStyle(0,DRAW_NONE);
               SetIndexStyle(1,DRAW_NONE);
            }

   
     //
     //
     //
     //
     //
      
     indicatorFileName = WindowExpertName();
     calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
     returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
     timeFrame         = stringToTimeFrame(TimeFrame);
      
     //
     //
     //
     //
     //
   
   IndicatorShortName(timeFrameToString(timeFrame)+"  CandleSize");
 return(0);
}

//
//
//
//
//

int deinit(){  return(0); }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { Bull[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
            
      for(i=limit; i>=0; i--)
      {
      double myDif = NormalizeDouble(MathAbs(Open[i] - Close[i]) / point, 4);
      
      trend[i] = trend[i+1];
         if (myDif >= CandleSize && Open[i] < Close[i]) trend[i] = 1;
         if (myDif >= CandleSize && Open[i] > Close[i]) trend[i] =-1;

         //
         //
         //
         //
         //
      
         Bull[i] = EMPTY_VALUE;
         Bear[i] = EMPTY_VALUE;
         if (trend[i] != trend[i+1])
         if (trend[i] == 1)
               Bull[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
         else  Bear[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
         }
         
   manageAlerts();
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Bull[i] = EMPTY_VALUE;
         Bear[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CandleSize,ShowArrows,2,y); 
         
         if (trend[i] != trend[i+1])
         if (trend[i] == 1)
               Bull[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
         else  Bear[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
         
   }
   manageAlerts();
   return(0);
   }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//


void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"Large BULL candle");
         if (trend[whichBar] ==-1) doAlert(whichBar,"Large BEAR candle");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" CandleSize ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," CandleSize "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//



   